import*as msalCommon from"@azure/msal-browser";import{AuthenticationRequiredError,CredentialUnavailableError}from"../errors";import{formatError,formatSuccess}from"../util/logging";import{DefaultAuthorityHost,DefaultTenantId}from"../constants";import{AbortError}from"@azure/abort-controller";import{isNode,randomUUID}from"@azure/core-util";const LatestAuthenticationRecordVersion="1.0";export function ensureValidMsalToken(e,r,o,t){const n=o=>(r.getToken.info(o),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:t,message:o}));if(!o)throw n("No response");if(!o.expiresOn)throw n('Response had no "expiresOn" property.');if(!o.accessToken)throw n('Response had no "accessToken" property.')}export function getAuthority(e,r){return r||(r=DefaultAuthorityHost),new RegExp(`${e}/?$`).test(r)?r:r.endsWith("/")?r+e:`${r}/${e}`}export function getKnownAuthorities(e,r,o){return"adfs"===e&&r||o?[r]:[]}export const defaultLoggerCallback=(e,r=(isNode?"Node":"Browser"))=>(o,t,n)=>{if(!n)switch(o){case msalCommon.LogLevel.Error:return void e.info(`MSAL ${r} V2 error: ${t}`);case msalCommon.LogLevel.Info:return void e.info(`MSAL ${r} V2 info message: ${t}`);case msalCommon.LogLevel.Verbose:return void e.info(`MSAL ${r} V2 verbose message: ${t}`);case msalCommon.LogLevel.Warning:return void e.info(`MSAL ${r} V2 warning: ${t}`)}};export function getMSALLogLevel(e){switch(e){case"error":return msalCommon.LogLevel.Error;case"info":default:return msalCommon.LogLevel.Info;case"verbose":return msalCommon.LogLevel.Verbose;case"warning":return msalCommon.LogLevel.Warning}}export class MsalBaseUtilities{constructor(e){this.logger=e.logger,this.account=e.authenticationRecord}generateUuid(){return randomUUID()}handleResult(e,r,o,t){return(null==o?void 0:o.account)&&(this.account=msalToPublic(r,o.account)),ensureValidMsalToken(e,this.logger,o,t),this.logger.getToken.info(formatSuccess(e)),{token:o.accessToken,expiresOnTimestamp:o.expiresOn.getTime()}}handleError(e,r,o){if("AuthError"===r.name||"ClientAuthError"===r.name||"BrowserAuthError"===r.name){const o=r;switch(o.errorCode){case"endpoints_resolution_error":return this.logger.info(formatError(e,r.message)),new CredentialUnavailableError(r.message);case"device_code_polling_cancelled":return new AbortError("The authentication has been aborted by the caller.");case"consent_required":case"interaction_required":case"login_required":this.logger.info(formatError(e,`Authentication returned errorCode ${o.errorCode}`));break;default:this.logger.info(formatError(e,`Failed to acquire token: ${r.message}`))}}return"ClientConfigurationError"===r.name||"BrowserConfigurationAuthError"===r.name||"AbortError"===r.name?r:new AuthenticationRequiredError({scopes:e,getTokenOptions:o,message:r.message})}}export function publicToMsal(e){const[r]=e.authority.match(/([a-z]*\.[a-z]*\.[a-z]*)/)||[""];return Object.assign(Object.assign({},e),{localAccountId:e.homeAccountId,environment:r})}export function msalToPublic(e,r){return{authority:getAuthority(r.tenantId,r.environment),homeAccountId:r.homeAccountId,tenantId:r.tenantId||DefaultTenantId,username:r.username,clientId:e,version:"1.0"}}export function serializeAuthenticationRecord(e){return JSON.stringify(e)}export function deserializeAuthenticationRecord(e){const r=JSON.parse(e);if(r.version&&"1.0"!==r.version)throw Error("Unsupported AuthenticationRecord version");return r}