import{loadConfig}from"@smithy/node-config-provider";import{CredentialsProviderError}from"@smithy/property-provider";import{InstanceMetadataV1FallbackError}from"./error/InstanceMetadataV1FallbackError";import{httpRequest}from"./remoteProvider/httpRequest";import{fromImdsCredentials,isImdsCredentials}from"./remoteProvider/ImdsCredentials";import{providerConfigFromInit}from"./remoteProvider/RemoteProviderInit";import{retry}from"./remoteProvider/retry";import{getInstanceMetadataEndpoint}from"./utils/getInstanceMetadataEndpoint";import{staticStabilityProvider}from"./utils/staticStabilityProvider";const IMDS_PATH="/latest/meta-data/iam/security-credentials/",IMDS_TOKEN_PATH="/latest/api/token",AWS_EC2_METADATA_V1_DISABLED="AWS_EC2_METADATA_V1_DISABLED",PROFILE_AWS_EC2_METADATA_V1_DISABLED="ec2_metadata_v1_disabled",X_AWS_EC2_METADATA_TOKEN="x-aws-ec2-metadata-token";export const fromInstanceMetadata=(t={})=>staticStabilityProvider(getInstanceImdsProvider(t),{logger:t.logger});const getInstanceImdsProvider=t=>{let e=!1;const{logger:r,profile:a}=t,{timeout:i,maxRetries:o}=providerConfigFromInit(t),n=async(r,i)=>{if(e||null==i.headers?.[X_AWS_EC2_METADATA_TOKEN]){let e=!1,r=!1;const i=await loadConfig({environmentVariableSelector:t=>{const e=t[AWS_EC2_METADATA_V1_DISABLED];if(r=!!e&&"false"!==e,void 0===e)throw new CredentialsProviderError(`${AWS_EC2_METADATA_V1_DISABLED} not set in env, checking config file next.`);return r},configFileSelector:t=>{const r=t.ec2_metadata_v1_disabled;return e=!!r&&"false"!==r,e},default:!1},{profile:a})();if(t.ec2MetadataV1Disabled||i){const a=[];throw t.ec2MetadataV1Disabled&&a.push("credential provider initialization (runtime option ec2MetadataV1Disabled)"),e&&a.push("config file profile (ec2_metadata_v1_disabled)"),r&&a.push(`process environment variable (${AWS_EC2_METADATA_V1_DISABLED})`),new InstanceMetadataV1FallbackError(`AWS EC2 Metadata v1 fallback has been blocked by AWS SDK configuration in the following: [${a.join(", ")}].`)}}const o=(await retry((async()=>{let t;try{t=await getProfile(i)}catch(t){throw 401===t.statusCode&&(e=!1),t}return t}),r)).trim();return retry((async()=>{let t;try{t=await getCredentialsFromProfile(o,i)}catch(t){throw 401===t.statusCode&&(e=!1),t}return t}),r)};return async()=>{const t=await getInstanceMetadataEndpoint();if(e)return r?.debug("AWS SDK Instance Metadata","using v1 fallback (no token fetch)"),n(o,{...t,timeout:i});{let a;try{a=(await getMetadataToken({...t,timeout:i})).toString()}catch(a){if(400===a?.statusCode)throw Object.assign(a,{message:"EC2 Metadata token request returned error"});return("TimeoutError"===a.message||[403,404,405].includes(a.statusCode))&&(e=!0),r?.debug("AWS SDK Instance Metadata","using v1 fallback (initial)"),n(o,{...t,timeout:i})}return n(o,{...t,headers:{[X_AWS_EC2_METADATA_TOKEN]:a},timeout:i})}}},getMetadataToken=async t=>httpRequest({...t,path:IMDS_TOKEN_PATH,method:"PUT",headers:{"x-aws-ec2-metadata-token-ttl-seconds":"21600"}}),getProfile=async t=>(await httpRequest({...t,path:IMDS_PATH})).toString(),getCredentialsFromProfile=async(t,e)=>{const r=JSON.parse((await httpRequest({...e,path:IMDS_PATH+t})).toString());if(!isImdsCredentials(r))throw new CredentialsProviderError("Invalid response received from instance metadata service.");return fromImdsCredentials(r)};